Attribute VB_Name = "INI_Functions"
Public Declare Function WritePrivateProfileString Lib "kernel32" _
  Alias "WritePrivateProfileStringA" ( _
  ByVal lpApplicationName As String, _
  ByVal lpKeyName As Any, _
  ByVal lpString As Any, _
  ByVal lpFileName As String) As Long
 
Public Declare Function GetPrivateProfileString Lib "kernel32" _
  Alias "GetPrivateProfileStringA" ( _
  ByVal lpApplicationName As String, _
  ByVal lpKeyName As Any, _
  ByVal lpDefault As String, _
  ByVal lpReturnedString As String, _
  ByVal nSize As Long, _
  ByVal lpFileName As String) As Long
  
Option Explicit
  
Public Function INI_Eintrag_speichern(Dateiname As String, Abschnitt As String, _
    Variable As String, Wert As String)

    Dim myIniFile As String
    ' Die INI Datei muss im Programmverzeichnis liegen
    myIniFile = App.Path & "\" & Dateiname & ".ini"

    ' Speichern des Eintrags in der INI-Datei
    WritePrivateProfileString Abschnitt, Variable, Wert, _
      myIniFile
End Function

Public Function INI_Eintrag_lschen(Dateiname As String, Abschnitt As String, _
    Variable As String)

    Dim myIniFile As String
    ' Die INI Datei muss im Programmverzeichnis liegen
    myIniFile = App.Path & "\" & Dateiname & ".ini"
    
    ' Lschen eines einzelnen Eintrags aus der INI-Datei
    WritePrivateProfileString "Start", "Tagestipp", vbNullString, _
      myIniFile
End Function

Public Function INI_Abschnitt_lschen(Dateiname As String, Abschnitt As String)

    Dim myIniFile As String
    ' Die INI Datei muss im Programmverzeichnis liegen
    myIniFile = App.Path & "\" & Dateiname & ".ini"

    ' Lschen eines gesamten Abschnittes
    WritePrivateProfileString "Start", vbNullString, "", myIniFile
End Function

Public Function INI_Alles_lschen(Dateiname As String)

    Dim myIniFile As String
    ' Die INI Datei muss im Programmverzeichnis liegen
    myIniFile = App.Path & "\" & Dateiname & ".ini"

    ' Lschen aller Abschnitte
    WritePrivateProfileString vbNullString, "", "", myIniFile
End Function

Public Function INI_Eintrag_lesen(Dateiname As String, Abschnitt As String, _
    Variable As String)
    
    Dim sValue As String
    Dim lResult As Long
 
    Dim myIniFile As String
    ' Die INI Datei muss im Programmverzeichnis liegen
    myIniFile = App.Path & "\" & Dateiname & ".ini"
 
    ' Rckgabewert mit ausreichend Leerzeichen fllen
    sValue = Space$(255)
    '
    lResult = GetPrivateProfileString(Abschnitt, Variable, _
        "", sValue, Len(sValue), myIniFile)
 
    ' tatschliche Lnge des Rckgabewertes
    INI_Eintrag_lesen = Left$(sValue, lResult)
End Function

Public Sub INI_Array_Speichern(Dateiname As String, Abschnitt As String, Variable As String, xarray() As String)
  Dim X As Integer
  Dim buffer As String
  
  'Feld in einen String mit Trennzeichen Chr$(0) umwandeln
  For X = LBound(xarray) To UBound(xarray)
    buffer = buffer & xarray(X) & " "
  Next X
    
  'String schreiben
  buffer = Left$(buffer, Len(buffer))
  INI_Eintrag_speichern Dateiname, Abschnitt, Variable, buffer
End Sub

Public Function INI_Array_Lesen(Dateiname As String, Abschnitt As String, Variable As String)
  'FUNKTIONIERT NOCH NICHT RICHTIG
  
  Exit Sub
  
  Dim buffer As String
  Dim xarray() As String
  Dim i As Integer
  Dim index As Integer
  Dim i_alt As Integer
  
  'String lesen
  buffer = INI_Eintrag_lesen(Dateiname, Abschnitt, Variable)
       
  If buffer <> "" Then
    'String mit Trennzeichen " " in ein Feld umwandeln
    ReDim xarray(0)
    
    i_alt = 1
    For i = 1 To Len(buffer)
      If Mid(buffer, i, 1) = " " Then
        index = index + 1
        ReDim Preserve xarray(index)
        
        xarray(index) = Mid(buffer, i_alt, InStr(i, buffer, " ") - i_alt)
        i_alt = i
        i = InStr(i, buffer, " ")
        If i = 0 Then i = Len(buffer)
      End If
    Next i
  End If
End Function
