Attribute VB_Name = "Subs"
Option Explicit

Public Sub LoadSettings()
  'Fixe Einstellungen des ComPorts
  COMPort.COMPort = 0
  COMPort.Settings = "19200,N,8,1"
  COMPort.Handshake = comNone
  COMPort.InputMode = comInputModeText
  
  frmMain.Com.Settings = COMPort.Settings
  frmMain.Com.Handshaking = COMPort.Handshake
  frmMain.Com.InputMode = COMPort.InputMode
  
  
  'INI Datei festlegen
  Einstellungen.INIFile = "Einstellungen" '.ini wird automatisch angehngt
  
  'INI-Werte Laden
  COMPort.COMPort = INI_Eintrag_lesen(Einstellungen.INIFile, "Programm", "COMPort")
  Einstellungen.ReloadTime = INI_Eintrag_lesen(Einstellungen.INIFile, "Programm", "AkInterval")
  Einstellungen.Logging = INI_Eintrag_lesen(Einstellungen.INIFile, "Programm", "Logging")
  
  Hardware.Modul.Heizung.Adresse = INI_Eintrag_lesen(Einstellungen.INIFile, "Heizung", "Adresse") + ": "
  Hardware.Modul.Regler.Adresse = INI_Eintrag_lesen(Einstellungen.INIFile, "Regler", "Adresse") + ": "
  
  'Hardwarebefehle zum Abfragen der Module einlesen
  Dim dummy As String
  Dim i As Integer
    
  'Heizung
  Do
    i = i + 1
    dummy = INI_Eintrag_lesen(Einstellungen.INIFile, "Heizung", "Abfrage" + Format(i))
    If dummy <> "" Then
      ReDim Preserve Hardware.Modul.Heizung.PollBefehle(i)
      Hardware.Modul.Heizung.PollBefehle(i) = dummy
    End If
  Loop Until dummy = ""
  
  'Regler
  Do
    i = i + 1
    dummy = INI_Eintrag_lesen(Einstellungen.INIFile, "Regler", "Abfrage" + Format(i))
    If dummy <> "" Then
      ReDim Preserve Hardware.Modul.Regler.PollBefehle(i)
      Hardware.Modul.Heizung.PollBefehle(i) = dummy
    End If
  Loop Until dummy = ""
  
End Sub

Public Sub SaveSettings()
  Dim dummy As Integer
  'Einstellungen speichern
  INI_Eintrag_speichern Einstellungen.INIFile, "Programm", "COMPort", Format(COMPort.COMPort)
  INI_Eintrag_speichern Einstellungen.INIFile, "Programm", "AkInterval", Format(Einstellungen.ReloadTime)
  INI_Eintrag_speichern Einstellungen.INIFile, "Programm", "Logging", Format(Einstellungen.Logging)
End Sub

'Kleine Warteschleife
Public Sub Warten()
  Dim i As Double
  
  For i = 1 To 1000
    DoEvents
  Next i
End Sub

'Auf Serielle Schnittstelle warten
Public Function WaitSeriell() As String
  Dim i As Double
  Dim buffer As String
  Dim dummy As String
    
  For i = 1 To 1000
    DoEvents
  Next i
  Do
    i = i + 1
    DoEvents
    dummy = frmMain.Com.Input
    If dummy <> "" Then buffer = buffer + dummy
  Loop Until i = 100000 Or InStr(buffer, vbCr) 'Or buffer <> ""
  
  'Timeout?
  If i = 100000 Then buffer = ""
  'MsgBox buffer
  WaitSeriell = buffer
End Function

'Seriellen String senden
Public Sub SendString(buffer As String)
  Dim i As Integer
  Dim j As Integer

  frmMain.Com.Output = Chr(13)
  For j = 1 To 5000
    DoEvents
  Next j
  
  For i = 1 To Len(buffer)
    'Zeichen senden
    frmMain.Com.Output = Mid(buffer, i, 1)
    For j = 1 To 1000
      DoEvents
    Next j
  Next i
  frmMain.Com.Output = Chr(13)
  For j = 1 To 1000
    DoEvents
  Next j

End Sub

'TemperaturLog in Excel Datei Starten
Public Function InitLogging() As Boolean
  On Error Resume Next
  
  'Fehler lschen
  Err.Clear
  
  'Prfen ob schon mitgeloggt wird
  If Einstellungen.LoggingActive Then
    InitLogging = False
    Exit Function
  End If
  
  'Logging in Datei starten
  Dim Datum As String
  Dim Zeit As String
  Dim Filename As String
  
  'Datum basteln
  Datum = Day(Date) & "." & Month(Date) & "." & Year(Date)
  'Zeit zusammenstellen
  Zeit = Hour(Time()) & "_" & Minute(Time()) & "_" & Second(Time())
  'Dateiname zusammenstellen
  Filename = "C:\TempLog_" & Datum & "_" & Zeit & ".csv"
  
  'Datei ffnen
  Einstellungen.LoggingFileNumber = FreeFile
  Open Filename For Output As Einstellungen.LoggingFileNumber
  
  Print #Einstellungen.LoggingFileNumber, "Raumtemperatur;Brennertemperatur;Kesseltemperatur"
  
  'Kein Fehler?
  If Err = 0 Then
    Einstellungen.LoggingActive = True
    InitLogging = True
  Else
    Einstellungen.LoggingActive = False
    InitLogging = False
  End If
End Function

'Temperaturen in Ecxel Datei eintragen
Public Function Logging(Raumtemp As String, Brennertemp As String, Kesseltemp As String)
  On Error Resume Next
  
  'Prfen ob berhaupt mitgeloggt wird
  If Not Einstellungen.LoggingActive Then
    Logging = False
    Exit Function
  End If
  
  'Werte in Datei schreiben
  Print #Einstellungen.LoggingFileNumber, Raumtemp; ";"; Brennertemp; ";"; Kesseltemp
  
  'Kein Fehler?
  If Err = 0 Then
    Logging = True
  Else
    Logging = False
  End If
End Function

'Logging beenden
Public Function ExitLogging() As Boolean
  On Error Resume Next
  
  'Prfen ob berhaupt mitgeloggt wird
  If Not Einstellungen.LoggingActive Then
    ExitLogging = False
    Exit Function
  End If
  
  'Logging beenden
  Close Einstellungen.LoggingFileNumber
  
  'Keine Fehler?
  If Err = 0 Then
    ExitLogging = True
  Else
    Err.Clear
  End If
End Function
